Patchwork [RFC,gdb/contrib] Fix gdb/contrib/gdb-add-index.sh for dwz-m-ed execs

login
register
mail settings
Submitter Tom de Vries
Date May 7, 2019, 4:13 p.m.
Message ID <a9b93e9b-3d9b-844c-4db4-d44c2e1a9e9e@suse.de>
Download mbox | patch
Permalink /patch/32595/
State New
Headers show

Comments

Tom de Vries - May 7, 2019, 4:13 p.m.
[ was: Re: [PATCH][gdb] Write index for dwz -m file ]


Hi,

This is a follow-up patch for "[gdb] Write index for dwz -m file".

Any comments on the updated gdb/contrib/gdb-add-index.sh script?

In particular, I'd like some advice on whether I should add shell
variables (as I've done for readelf) for grep, tail and sed.

Thanks,
- Tom

Patch

[gdb/contrib] Fix gdb/contrib/gdb-add-index.sh for dwz-m-ed execs

Atm gdb-add-index.exp fails with target board cc-with-dwz-m.

Fix this by updating gdb/contrib/gdb-add-index.sh to handle a dwz-m-ed
executable.

Tested on x86_64-linux.

gdb/ChangeLog:

2019-05-07  Tom de Vries  <tdevries@suse.de>

	PR gdb/24445
	* contrib/gdb-add-index.sh: Update to handle dwz-m-ed executable.

---
 gdb/contrib/gdb-add-index.sh | 134 +++++++++++++++++++++++++++----------------
 1 file changed, 86 insertions(+), 48 deletions(-)

diff --git a/gdb/contrib/gdb-add-index.sh b/gdb/contrib/gdb-add-index.sh
index efaad1dce7..afedce0c84 100755
--- a/gdb/contrib/gdb-add-index.sh
+++ b/gdb/contrib/gdb-add-index.sh
@@ -20,6 +20,7 @@ 
 # If not, or you want others, pass the following in the environment
 GDB=${GDB:=gdb}
 OBJCOPY=${OBJCOPY:=objcopy}
+READELF=${READELF:=readelf}
 
 myname="${0##*/}"
 
@@ -43,15 +44,40 @@  fi
 
 dir="${file%/*}"
 test "$dir" = "$file" && dir="."
-index4="${file}.gdb-index"
-index5="${file}.debug_names"
-debugstr="${file}.debug_str"
-debugstrmerge="${file}.debug_str.merge"
-debugstrerr="${file}.debug_str.err"
 
-rm -f $index4 $index5 $debugstr $debugstrmerge $debugstrerr
+dwz_file=""
+if $READELF -S "$file" | grep -q " \.gnu_debugaltlink "; then
+    dwz_file=$($READELF --string-dump=.gnu_debugaltlink "$file" \
+		   | grep -A1  "'\.gnu_debugaltlink':" \
+		   | tail -n +2 \
+		   | sed 's/.*]//')
+    dwz_file=$(echo $dwz_file)
+fi
+
+set_files ()
+{
+    local file="$1"
+
+    index4="${file}.gdb-index"
+    index5="${file}.debug_names"
+    debugstr="${file}.debug_str"
+    debugstrmerge="${file}.debug_str.merge"
+    debugstrerr="${file}.debug_str.err"
+}
+
+tmp_files=
+for f in "$file" "$dwz_file"; do
+    if [ "$f" = "" ]; then
+	continue
+    fi
+    set_files "$file"
+    tmp_files="$tmp_files $index4 $index5 $debugstr $debugstrmerge $debugstrerr"
+done
+
+rm -f $tmp_files
+
 # Ensure intermediate index file is removed when we exit.
-trap "rm -f $index4 $index5 $debugstr $debugstrmerge $debugstrerr" 0
+trap "rm -f $tmp_files" 0
 
 $GDB --batch -nx -iex 'set auto-load no' \
     -ex "file $file" -ex "save gdb-index $dwarf5 $dir" || {
@@ -67,50 +93,62 @@  $GDB --batch -nx -iex 'set auto-load no' \
 # already stripped binary, it's a no-op.
 status=0
 
-if test -f "$index4" -a -f "$index5"; then
-    echo "$myname: Both index types were created for $file" 1>&2
-    status=1
-elif test -f "$index4" -o -f "$index5"; then
-    if test -f "$index4"; then
-	index="$index4"
-	section=".gdb_index"
-    else
-	index="$index5"
-	section=".debug_names"
-    fi
-    debugstradd=false
-    debugstrupdate=false
-    if test -s "$debugstr"; then
-	if ! $OBJCOPY --dump-section .debug_str="$debugstrmerge" "$file" /dev/null \
-		 2>$debugstrerr; then
-	    cat >&2 $debugstrerr
-	    exit 1
-	fi
-	if grep -q "can't dump section '.debug_str' - it does not exist" \
-		  $debugstrerr; then
-	    debugstradd=true
+handle_file ()
+{
+    local file
+    file="$1"
+
+    set_files "$file"
+
+    if test -f "$index4" -a -f "$index5"; then
+	echo "$myname: Both index types were created for $file" 1>&2
+	status=1
+    elif test -f "$index4" -o -f "$index5"; then
+	if test -f "$index4"; then
+	    index="$index4"
+	    section=".gdb_index"
 	else
-	    debugstrupdate=true
-	    cat >&2 $debugstrerr
+	    index="$index5"
+	    section=".debug_names"
+	fi
+	debugstradd=false
+	debugstrupdate=false
+	if test -s "$debugstr"; then
+	    if ! $OBJCOPY --dump-section .debug_str="$debugstrmerge" "$file" \
+		 /dev/null 2>$debugstrerr; then
+		cat >&2 $debugstrerr
+		exit 1
+	    fi
+	    if grep -q "can't dump section '.debug_str' - it does not exist" \
+		    $debugstrerr; then
+		debugstradd=true
+	    else
+		debugstrupdate=true
+		cat >&2 $debugstrerr
+	    fi
+	    cat "$debugstr" >>"$debugstrmerge"
 	fi
-	cat "$debugstr" >>"$debugstrmerge"
-    fi
 
-    $OBJCOPY --add-section $section="$index" \
-	--set-section-flags $section=readonly \
-	$(if $debugstradd; then \
-	      echo --add-section .debug_str="$debugstrmerge"; \
-	      echo --set-section-flags .debug_str=readonly; \
-	  fi; \
-	  if $debugstrupdate; then \
-	      echo --update-section .debug_str="$debugstrmerge"; \
-	  fi) \
-	"$file" "$file"
+	$OBJCOPY --add-section $section="$index" \
+		 --set-section-flags $section=readonly \
+		 $(if $debugstradd; then \
+		       echo --add-section .debug_str="$debugstrmerge"; \
+		       echo --set-section-flags .debug_str=readonly; \
+		   fi; \
+		   if $debugstrupdate; then \
+		       echo --update-section .debug_str="$debugstrmerge"; \
+		   fi) \
+		 "$file" "$file"
+
+	status=$?
+    else
+	echo "$myname: No index was created for $file" 1>&2
+	echo "$myname: [Was there no debuginfo? Was there already an index?]" \
+	     1>&2
+    fi
+}
 
-    status=$?
-else
-    echo "$myname: No index was created for $file" 1>&2
-    echo "$myname: [Was there no debuginfo? Was there already an index?]" 1>&2
-fi
+handle_file "$file"
+handle_file "$dwz_file"
 
 exit $status